<script>
    import Dropzone from "svelte-file-dropzone";
    import IconButton, { Icon } from '@smui/icon-button/styled';
    import { mdiClose } from '@mdi/js';
    import Svg from '@smui/common/Svg.svelte';
    import { window, loading } from "./scripts/stores";
    import { createEventDispatcher } from "svelte"

    let files = {
        accepted: [],
        rejected: []
    };

    let tableName= "";

    let uploadTableDispatcher = createEventDispatcher()

    function handleFilesSelect(e) {
    const { acceptedFiles, fileRejections } = e.detail;
    files.accepted = [...files.accepted, ...acceptedFiles];
    files.rejected = [...files.rejected, ...fileRejections];
    }

    function closeUploadWindow() {
      window.update(() => "false");
    }

    // upload a table in a file (e.g. CSV) after extracting the file and a name
    // from the upload table form
    async function uploadTable(){
    if (files.accepted.length == 0)
      alert("No file chosen.");
    else if (tableNameError(tableName) !== "")
      alert(tableNameError(tableName));
      else {
        uploadTableUnconditional(tableName, files.accepted[0])
        closeUploadWindow()
        loading.update(() => "true")
      }
    }
    
    function uploadTableUnconditional(tableName, file){
        uploadTableDispatcher("uploadtable", {
        upload_name: tableName,
        upload_file: file
        })
    }
    
    // returns an error message if a table name is unacceptable, otherwise ""
    function tableNameError(name){
        if (name === "")
        return "No table name given."
        else if(!name.match(/^[a-zA-Z][a-zA-Z0-9_\-]*$/))
        return "Name must start with a letter and contain only"
        + " letters, numbers, and underscores."
        else
        return ""
    } 
</script>


<div class="upload-window">
    <div class="upload-dialog">
        <div class="upload-content">
            <div class="upload-header">
                <h2 style="text-align: center;">Upload CSV-File</h2>
                <IconButton class="close-upload-window" on:click={closeUploadWindow}>
                    <Icon component={Svg} viewBox="0 0 24 24">
                      <path fill="currentColor" d={mdiClose} />
                    </Icon>
                </IconButton>
            </div>
            <div class="upload-selector">
                {#if files.accepted == ''}
                <Dropzone class="dropzone" type="file" accept=".csv" on:drop={handleFilesSelect} multiple="false"/>
                {/if}
                {#each files.accepted as item}
                    <h3>{item.name}</h3>
                {/each}
            </div>
            <div class="upload-footer">
                <form class="tablename-set">
                    <label for= "tableName" >TableName:</label>
                    <input type="text" bind:value={tableName}>
                </form>
                <button class="submit-upload" on:click={uploadTable}>
                    Submit
                </button>
            </div>
        </div>
    </div>
</div>

